import { InfernoChildren, Props, Refs, VNode } from './implementation';
export declare function rerender(): void;
export declare type ComponentType<P = {}> = ComponentClass<P> | StatelessComponent<P>;
export declare type SFC<P = {}> = StatelessComponent<P>;
export interface StatelessComponent<P = {}> {
    (props: P & {
        children?: InfernoChildren;
    }, context?: any): VNode<P> | null;
    defaultProps?: Partial<P>;
    displayName?: string;
    defaultHooks?: Refs<P>;
}
export interface ComponentClass<P = {}, S = {}> {
    new (props?: P, context?: any): Component<P, {}>;
    defaultProps?: Partial<P>;
    displayName?: string;
    refs?: any;
    componentDidMount?(): void;
    /**
     * @deprecated since version 6.0
     */
    componentWillMount?(): void;
    /**
     * @deprecated since version 6.0
     */
    componentWillReceiveProps?(nextProps: P, nextContext: any): void;
    shouldComponentUpdate?(nextProps: P, nextState: S, context: any): boolean;
    /**
     * @deprecated since version 6.0
     */
    componentWillUpdate?(nextProps: P, nextState: S, context: any): void;
    componentDidUpdate?(prevProps: P, prevState: S, snapshot: any): void;
    componentWillUnmount?(): void;
    getChildContext?(): void;
}
export interface Component<P = {}, S = {}> extends ComponentClass<P, S> {
}
export declare class Component<P, S> {
    static defaultProps: any;
    state: S | null;
    props: Props<P, this> & P;
    context: any;
    refs?: any;
    $BR: boolean;
    $BS: boolean;
    $PSS: boolean;
    $PS: S | null;
    $LI: any;
    $UN: boolean;
    $CX: null;
    $UPD: boolean;
    $QU: Function[] | null;
    $N: boolean;
    $SSR?: boolean;
    $REF?: any;
    constructor(props?: P, context?: any);
    forceUpdate(callback?: Function): void;
    setState(newState: {
        [k in keyof S]?: S[k];
    } | Function, callback?: Function): void;
    getSnapshotBeforeUpdate?(prevProps: Props<any>, prevState: S): any;
    static getDerivedStateFromProps?(nextProps: Props<any>, state: any): any;
    render(_nextProps: P, _nextState: any, _nextContext: any): any;
}
